## tillitis-tkey-libs 0.1.2

=== Makefile ===
OBJCOPY ?= llvm-objcopy

CC = clang

INCLUDE=include

# Note that QEMU_DEBUG needs to be defined!
CFLAGS = -target riscv32-unknown-none-elf -march=rv32iczmmul -mabi=ilp32 \
	-mcmodel=medany -static -std=gnu99 -O2 -ffast-math -fno-common \
	-fno-builtin-printf -fno-builtin-putchar -nostdlib -mno-relax -flto \
	-Wall -Werror=implicit-function-declaration \
	-I $(INCLUDE) -I . -D QEMU_DEBUG

AS = clang
AR = llvm-ar
ASFLAGS = -target riscv32-unknown-none-elf -march=rv32iczmmul -mabi=ilp32 \
	-mcmodel=medany -mno-relax

LDFLAGS=-T app.lds -L libcommon/ -lcommon -L libcrt0/ -lcrt0


.PHONY: all
all: libcrt0.a libcommon.a libmonocypher.a

IMAGE=ghcr.io/tillitis/tkey-builder:4

podman:
	podman run --rm --mount type=bind,source=$(CURDIR),target=/src \
	-w /src -it $(IMAGE) make -j

.PHONY: check
check:
	clang-tidy -header-filter=.* -checks=cert-* libcommon/*.c -- $(CFLAGS)

# C runtime library
libcrt0.a: libcrt0/crt0.o
	$(AR) -qc $@ libcrt0/crt0.o

# Common C functions
LIBOBJS=libcommon/assert.o libcommon/blake2s.o libcommon/led.o libcommon/lib.o \
	libcommon/proto.o libcommon/touch.o libcommon/qemu_debug.o
libcommon.a: $(LIBOBJS)
	$(AR) -qc $@ $(LIBOBJS)
$(LIBOBJS): include/tkey/assert.h include/tkey/blake2s.h  include/tkey/led.h \
	include/tkey/lib.h include/tkey/proto.h include/tkey/tk1_mem.h \
	include/tkey/touch.h include/tkey/qemu_debug.h

# Monocypher
MONOOBJS=monocypher/monocypher.o monocypher/monocypher-ed25519.o
libmonocypher.a: $(MONOOBJS)
	$(AR) -qc $@ $(MONOOBJS)
$MONOOBJS: monocypher/monocypher-ed25519.h monocypher/monocypher.h

LIBS=libcrt0.a libcommon.a

.PHONY: clean
clean:
	rm -f $(LIBS) $(LIBOBJS) libcrt0/crt0.o
	rm -f libmonocypher.a $(MONOOBJS)

# Create compile_commands.json for clangd and LSP
.PHONY: clangd
clangd: compile_commands.json
compile_commands.json:
	$(MAKE) clean
	bear -- make all

# Uses ../.clang-format
FMTFILES=include/tkey/*.h libcommon/*.c
.PHONY: fmt
fmt:
	clang-format --dry-run --ferror-limit=0 $(FMTFILES)
	clang-format --verbose -i $(FMTFILES)
.PHONY: checkfmt
checkfmt:
	clang-format --dry-run --ferror-limit=0 --Werror $(FMTFILES)

.PHONY: update-mem-include
update-mem-include:
	cp -af ../tillitis-key1/hw/application_fpga/fw/tk1_mem.h \
	include/tkey/tk1_mem.h
	echo "Remember to update header include guard!"

=== example-app/Makefile ===
P := $(shell dirname $(realpath $(lastword $(MAKEFILE_LIST))))
LIBDIR ?= $(P)/../
OBJCOPY ?= llvm-objcopy
CC = clang
CFLAGS = -g -target riscv32-unknown-none-elf -march=rv32iczmmul -mabi=ilp32 -mcmodel=medany \
   -static -std=gnu99 -O2 -ffast-math -fno-common -fno-builtin-printf \
   -fno-builtin-putchar -nostdlib -mno-relax -flto \
   -Wall -Werror=implicit-function-declaration \
   -I $(LIBDIR)/include -I $(LIBDIR)  \
#   -D QEMU_DEBUG

INCLUDE=$(LIBDIR)/include

LDFLAGS=-T $(LIBDIR)/app.lds -L $(LIBDIR) -lcommon -lcrt0

.PHONY: all
all: blue.bin

# Turn elf into bin for device
%.bin: %.elf
	$(OBJCOPY) --input-target=elf32-littleriscv --output-target=binary $^ $@
	chmod a-x $@

BLUEOBJS=blue.o
blue.elf: blue.o
	$(CC) $(CFLAGS) $(BLUEOBJS) $(LDFLAGS) -I $(LIBDIR) -o $@

.PHONY: clean
clean:
	rm -f blue.bin blue.elf $(BLUEOBJS)

=== debian/changelog ===
tillitis-tkey-libs (0.1.2-2) unstable; urgency=medium

  * Bump debian/* copyright years.
  * salsa-ci: Build reverse dep device-signer.
  * Pin to clang/llvm 19 for reproducibility.
  * Make package team-maintained by pkg-security.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 03 Feb 2025 13:00:55 +0100

tillitis-tkey-libs (0.1.2-1) unstable; urgency=medium

  * Initial release (Closes: #1087422)

 -- Simon Josefsson <simon@josefsson.org>  Wed, 13 Nov 2024 11:46:02 +0100

=== debian/control ===
Source: tillitis-tkey-libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 clang-19,
 clang-tidy-19 <!nocheck>,
 llvm-19,
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/tillitis/tkey-libs
Vcs-Browser: https://salsa.debian.org/debian/tillitis-tkey-libs
Vcs-Git: https://salsa.debian.org/debian/tillitis-tkey-libs.git
Rules-Requires-Root: no

Package: tillitis-tkey-libs
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Tillitis TKey device application helper library
 Device libraries for the Tillitis TKey
 .
  - C runtime: libcrt0.
  - Common C functions including protocol calls: libcommon.
  - Cryptographic functions: libmonocypher.
 .
 This package contains C headers and RISCv32 library object files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make CC="clang-19" AR="llvm-ar-19"

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make CLANG_TIDY="clang-tidy-19" check
endif

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/tillitis/tkey-libs/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
